package no.johnsrud.addressbook1service;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

import no.johnsrud.addressbooksh.ContactBook;

import com.jcraft.jzlib.ZOutputStream;
import com.sun.org.apache.xerces.internal.impl.dv.util.Base64;

//import no.johnsrud.addressbook1service.base64.Base64;

public class DataRepository {

	private String baseUrl;
	
	private String fredrikPlain, fredrikZlib, fredrikEfx, fredrikEfxZlib;
	private String annePlain, anneZlib, anneEfx, anneEfxZlib;
	private String larsPlain, larsZlib, larsEfx, larsEfxZlib;
	private String elinPlain, elinZlib, elinEfx, elinEfxZlib;
	private String josteinPlain, josteinZlib, josteinEfx, josteinEfxZlib;
	private String susannePlain, susanneZlib, susanneEfx, susanneEfxZlib;
	private String haraldPlain, haraldZlib, haraldEfx, haraldEfxZlib;
	private String kristinPlain, kristinZlib, kristinEfx, kristinEfxZlib;
	
	private String perPlain, perZlib, perEfx, perEfxZlib;
	private String olePlain, oleZlib, oleEfx, oleEfxZlib;
	
	
	private String[] plain;
	private String[] zlib;
	private String[] efx;
	private String[] efxZip;
	private int set=0;
	
	
	public DataRepository(){
		baseUrl="z:/master/dev/data/";
		plain=new String[14];
		zlib=new String[14];
		efx=new String[14];
		efxZip=new String[14];
		
		
		initData();
		
	}
	
	private void initData(){
		preapere("Fredrik");
		preapere("Anne");
		preapere("Lars");
		preapere("Elin");
		preapere("Jostein");
		preapere("Susanne");
		preapere("Harald");
		preapere("Kristin");
		preapere("Trine");
		preapere("Marianne");
		preapere("Mathias");
		preapere("Ida");
		preapere("Per");
		preapere("Ole");
	}
	
	private void preapere(String name){
		
		byte[] inBytes = readFile(baseUrl+name+".xml");
		byte[] inBytesEfx = readFile(baseUrl+name+".xml.efx");
		byte[] zlibBytes1= readFile(baseUrl+name+".xml.efx.zip");
		
		plain[set]=encodeBase64(inBytes);
		efx[set]=this.encodeBase64(inBytesEfx);
		byte[] zlibBytes = this.zlibBytes(inBytes);
		zlib[set]=this.encodeBase64(zlibBytes);
		efxZip[set]=this.encodeBase64(zlibBytes1);
		set++;
		
		

				
	}
	
	
	public String getPlain(String name){
		String res="feil";
		
		if(name.equalsIgnoreCase("lars")){
			res = plain[2];
		}
		else if(name.equalsIgnoreCase("per")){
			res = plain[12];
		}
		else if(name.equalsIgnoreCase("ole")){
			res = plain[13];
		}
		else if(name.equalsIgnoreCase("fredrik")){
			res = plain[0];
		}
		else if(name.equalsIgnoreCase("anne")){
			res = plain[1];
		}
		else if(name.equalsIgnoreCase("elin")){
			res = plain[3];
		}
		else if(name.equalsIgnoreCase("jostein")){
			res = plain[4];
		}
		else if(name.equalsIgnoreCase("susanne")){
			res = plain[5];
		}
		else if(name.equalsIgnoreCase("harald")){
			res = plain[6];
		}
		else if(name.equalsIgnoreCase("kristin")){
			res = plain[7];
		}
		else if(name.equalsIgnoreCase("trine")){
			res = plain[8];
		}
		else if(name.equalsIgnoreCase("marianne")){
			res = plain[9];
		}
		else if(name.equalsIgnoreCase("mathias")){
			res = plain[10];
		}
		else if(name.equalsIgnoreCase("ida")){
			res = plain[11];
		}
		
		return res;
	}
	
	public String getZlib(String name){
		String res="feil";
		
		if(name.equalsIgnoreCase("lars")){
			res = zlib[2];
		}
		else if(name.equalsIgnoreCase("per")){
			res = zlib[12];
		}
		else if(name.equalsIgnoreCase("ole")){
			res = zlib[13];
		}
		else if(name.equalsIgnoreCase("fredrik")){
			res = zlib[0];
		}
		else if(name.equalsIgnoreCase("anne")){
			res = zlib[1];
		}
		else if(name.equalsIgnoreCase("elin")){
			res = zlib[3];
		}
		else if(name.equalsIgnoreCase("jostein")){
			res = zlib[4];
		}
		else if(name.equalsIgnoreCase("susanne")){
			res = zlib[5];
		}
		else if(name.equalsIgnoreCase("harald")){
			res = zlib[6];
		}
		else if(name.equalsIgnoreCase("kristin")){
			res = zlib[7];
		}
		else if(name.equalsIgnoreCase("trine")){
			res = zlib[8];
		}
		else if(name.equalsIgnoreCase("marianne")){
			res = zlib[9];
		}
		else if(name.equalsIgnoreCase("mathias")){
			res = zlib[10];
		}
		else if(name.equalsIgnoreCase("ida")){
			res = zlib[11];
		}
		
		return res;
	}	
	
	public String getEfx(String name){
		String res="feil";
		
		if(name.equalsIgnoreCase("lars")){
			res = efx[2];
		}
		else if(name.equalsIgnoreCase("per")){
			res = efx[12];
		}
		else if(name.equalsIgnoreCase("ole")){
			res = efx[13];
		}
		else if(name.equalsIgnoreCase("fredrik")){
			res = efx[0];
		}
		else if(name.equalsIgnoreCase("anne")){
			res = efx[1];
		}
		else if(name.equalsIgnoreCase("elin")){
			res = efx[3];
		}
		else if(name.equalsIgnoreCase("jostein")){
			res = efx[4];
		}
		else if(name.equalsIgnoreCase("susanne")){
			res = efx[5];
		}
		else if(name.equalsIgnoreCase("harald")){
			res = efx[6];
		}
		else if(name.equalsIgnoreCase("kristin")){
			res = efx[7];
		}
		else if(name.equalsIgnoreCase("trine")){
			res = efx[8];
		}
		else if(name.equalsIgnoreCase("marianne")){
			res = efx[9];
		}
		else if(name.equalsIgnoreCase("mathias")){
			res = efx[10];
		}
		else if(name.equalsIgnoreCase("ida")){
			res = efx[11];
		}
		
		return res;
	}	
	
	public String getEfxZlib(String name){
		String res="feil";
		
		if(name.equalsIgnoreCase("lars")){
			res = efxZip[2];
		}
		else if(name.equalsIgnoreCase("per")){
			res = efxZip[12];
		}
		else if(name.equalsIgnoreCase("ole")){
			res = efxZip[13];
		}
		else if(name.equalsIgnoreCase("fredrik")){
			res = efxZip[0];
		}
		else if(name.equalsIgnoreCase("anne")){
			res = efxZip[1];
		}
		else if(name.equalsIgnoreCase("elin")){
			res = efxZip[3];
		}
		else if(name.equalsIgnoreCase("jostein")){
			res = efxZip[4];
		}
		else if(name.equalsIgnoreCase("susanne")){
			res = efxZip[5];
		}
		else if(name.equalsIgnoreCase("harald")){
			res = efxZip[6];
		}
		else if(name.equalsIgnoreCase("kristin")){
			res = efxZip[7];
		}
		else if(name.equalsIgnoreCase("trine")){
			res = efxZip[8];
		}
		else if(name.equalsIgnoreCase("marianne")){
			res = efxZip[9];
		}
		else if(name.equalsIgnoreCase("mathias")){
			res = efxZip[10];
		}
		else if(name.equalsIgnoreCase("ida")){
			res = efxZip[11];
		}
		
		return res;
	}
	
	public ContactBook getXMLPlain(String name){
		

    	no.johnsrud.addressbooksh.ContactBook cb = new no.johnsrud.addressbooksh.ContactBook();
    	no.johnsrud.addressbooksh.Contact c1 = new no.johnsrud.addressbooksh.Contact();
    	no.johnsrud.addressbooksh.Contact c2 = new no.johnsrud.addressbooksh.Contact();
    	c1.setFirstName("Lars");
    	c1.setLastName("Johnsrud");
    	c1.setPhoneNumber(99646063);
    	c1.setAddress("Gaasbuv 50");
    	c1.setEMail("johnsrud@stud.ntnu.no");
    	c1.setPostalCode(2323);
    	c1.setTown("Ingeberg");
    	
    	c2.setFirstName("Lars");
    	c2.setLastName("Laffen");
    	c2.setPhoneNumber(956478764);
    	c2.setAddress("Oppi lia");
    	c2.setEMail("heisann@vang.com");
    	c2.setPostalCode(1234);
    	c2.setTown("Fjellet");
    	
    	cb.addContacts(c1);
    	cb.addContacts(c2);
    	return cb;
	}
	
	
	private String encodeBase64(byte[] toEncode){
		String base64;
		base64 = Base64.encode(toEncode);
		
		
		return base64;
	}
	private byte[] readFile(String fileName){
		byte[] inputBytes = null;
		
		FileInputStream fis;
		try {
			fis = new FileInputStream(fileName);
			inputBytes = new byte[fis.available()];
			fis.read(inputBytes);
			fis.close();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return inputBytes;
	}
	
	private byte[] gZipBytes(byte[] inBytes){
		byte[] gZipBytes = null;
		
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
	
		
		try {
			java.util.zip.GZIPOutputStream zipout = new java.util.zip.GZIPOutputStream(baos);
			zipout.write(inBytes);
			zipout.flush();
			zipout.close();
			gZipBytes = baos.toByteArray();
			baos.close();
		
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return gZipBytes;
	}
	
	private byte[] zlibBytes(byte[] inBytes){
		byte[] zlibByte=null;
		
		ByteArrayOutputStream out =new ByteArrayOutputStream();
		ZOutputStream zOut = new ZOutputStream(out, com.jcraft.jzlib.JZlib.Z_BEST_COMPRESSION);
		
		try {
			zOut.write(inBytes);
			zOut.flush();
			zOut.close();
			zlibByte=out.toByteArray();
			
			
			out.close();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return zlibByte;
	}
	
	
	
	
	
	
}
