package client.mid1;

import org.xml.sax.Attributes;
import org.xml.sax.helpers.DefaultHandler;

import client.ws.Contact;

public class ContactHandler extends DefaultHandler {

	private String currentName;
	private boolean newElement=false;
	private Contact temp= null;
	private SonyMidlet parent;
	
	public void startElement(java.lang.String uri, java.lang.String localName, java.lang.String qName, Attributes attributes){
		currentName=qName;
		//System.out.println(currentName);
		newElement=true;
	}
	
	public ContactHandler(SonyMidlet mid){
		parent = mid;
	
	}
	
	public void characters(char[] ch, int start, int length){
		
		if(currentName.equalsIgnoreCase("Contacts")){

			//System.out.println("XXXX ny contact");
			temp = new Contact();
		}
		
		
		if(newElement){

			
			//System.out.println(currentName);
			//System.out.println(String.valueOf(ch, start, length));
			
			if(currentName.equalsIgnoreCase("firstName")){
				temp.setFirstName(String.valueOf(ch, start, length));
			}
			else if(currentName.equalsIgnoreCase("lastName")){
				temp.setLastName(String.valueOf(ch, start, length));
			}
			else if(currentName.equalsIgnoreCase("phoneNumber")){
				temp.setPhoneNumber(Integer.parseInt(String.valueOf(ch, start, length)));
			}		
			else if(currentName.equalsIgnoreCase("eMail")){
				temp.setEMail(String.valueOf(ch, start, length));
			}
			else if(currentName.equalsIgnoreCase("Address")){
				temp.setAddress(String.valueOf(ch, start, length));
			}
			else if(currentName.equalsIgnoreCase("PostalCode")){
				temp.setPostalCode(Integer.parseInt(String.valueOf(ch, start, length)));
			}
			else if(currentName.equalsIgnoreCase("Town")){
				temp.setTown(String.valueOf(ch, start, length));
				parent.resScreen.addEntry(temp);
			}
			else{
				System.out.println("feil i contacthandler");
			}
			
		
		newElement=false;
		}
		
		
	}
	
}
