package client.mid1;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.Calendar;
import java.util.Date;
import java.util.TimeZone;

import javax.microedition.io.ConnectionNotFoundException;
import javax.microedition.io.Connector;
import javax.microedition.io.OutputConnection;
import javax.microedition.io.file.FileConnection;
import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.AlertType;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.Item;
import javax.microedition.lcdui.ItemCommandListener;
import javax.microedition.lcdui.StringItem;
import javax.microedition.lcdui.TextField;
import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import master.dev.base64.Base64Coder;

import com.agiledelta.efx.EFXException;
import com.agiledelta.efx.EFXProperty;
import com.agiledelta.efx.EFXStreamReader;
import com.agiledelta.efx.microedition.EFXFactory;
import com.jcraft.jzlib.JZlib;
import com.sun.midp.io.Base64;
//import com.sun.midp.io.Base64;





import client.ws.AddressBook1PortType_Stub;
import client.ws.Contact;
import client.ws.ContactBook;


public class SonyMidlet extends MIDlet implements ItemCommandListener,
		CommandListener {

	protected Form form;
	protected Thread wsThread;
	protected TextField textField;
	protected StringItem inputQ = new StringItem(null, null);
	protected Date startT;
	protected Date stopT;
	protected long time =0;
	protected TextField name;
	protected String type;
	protected String name1;
	protected String measurements, prosRes, test;
	protected AddressBook1PortType_Stub wsStub;
	protected StringItem okButton, compButton, zLibButton, efxButton, testButton, ezButton;
	protected int number1=0;
	protected boolean ny =true;
	protected WsThread ws;
	protected boolean ready=true;
	protected String[] res;
	protected int resint=0;
	protected EFXFactory efx;
	protected Display d;
	protected Info inf;

	
	protected Result resScreen;
	
	protected Form getForm() {
		if (form == null) {
			form = new Form("Phone Book");
			}
		return form;
	}
	
	public SonyMidlet() {
		//setter dato i dag for mlingene
		this.measurements = new Date().toString()+"\r\n \r\n";
		this.measurements = measurements+"  Time to retrive inofrmation";
		this.prosRes="\r\n\r\n  Processing results:";
		inf = new Info();

		try {
			efx = EFXFactory.newInstance();
			//System.out.println(efx.getProperty(EFXProperty.ZIP));
			//System.out.println(efx.getProperty(EFXProperty.EXTENSIBLE));
			//efx.setProperty(EFXProperty.ZIP, new Boolean(true));
    		InputStream is1 = getClass().getResourceAsStream("/data/AddressBookSh.cxs");
			efx.setSchema(is1);
			is1.close();
		} catch (Exception e) {	
			Alert inf=new Alert("FEIL!");
			inf.setType(AlertType.ERROR);
			inf.setTimeout(50000);
			inf.setString(e.getMessage());
			
			e.printStackTrace();			
		}
		
		wsStub = new AddressBook1PortType_Stub();
		ws = new WsThread(this);
		initButtons();
		d =Display.getDisplay(this);
	}
	
	/*
	 * Skriver all info om mlinger til fil
	 */
	protected void updateMeasurements(){
			
		Calendar c = Calendar.getInstance(TimeZone.getTimeZone("Oslo"));
		
		int s = c.get(Calendar.SECOND);
		int mi =  c.get(Calendar.MINUTE);
		int h = c.get(Calendar.HOUR);
		int d = c.get(Calendar.DAY_OF_MONTH);
		int mo = c.get(Calendar.MONTH);		
		
		String fileURL ="measurement"+"-"+ String.valueOf(mo)+"-"+String.valueOf(d)+"-"+String.valueOf(h)+"-"+String.valueOf(mi)+"-"+String.valueOf(s)+".txt";
		String URL = "file:///e:/other/Java/"+fileURL;
		try {
			FileConnection conn = (FileConnection) Connector.open(URL);
			conn.create();

			OutputStream out = conn.openOutputStream();
            PrintStream print = new PrintStream( out );
            
            conn.close(); // doesn't close output stream!
 
            //print.println(measurements);
            print.print(measurements);
            print.println(prosRes);
            print.print(test);
  
            out.close();
		
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	/*
	 * Updates the measurements from the retrivel of information
	 */
	protected void setRetTime(long t, String name, int antallByte, String type1){
		measurements= measurements+"\r\n"+type1+"	"+name+"	"+"bytes: "+antallByte+"	ms: "+String.valueOf(t); 
		
		resScreen.setTimeRet(t);
	}
	/*
	 * Updates the measurements from the prosessing of information
	 */	
	protected void setTimePros(long start, long stop, int bytes){
		prosRes= prosRes+"\r\n"+type+"	"+name.getString()+"	"+"bytes: "+String.valueOf(bytes)+"	ms: "+String.valueOf(stop-start);
		
	}
	
	protected void setTimePros(String name, String plain, String efx){
		prosRes= prosRes+"\r\n"+name+"\r\n"+plain+"\r\n"+efx;
	}
	
	protected void setTest(String t){
		test=t;
	}
	
	
	/*
	 * Method that takes an base64 encoded string an returns a 
	 * byte array representation of the decoded strin
	 */
	private byte[] Base64Decode(String enc){
		
		byte[] dec=null;
		try{
			dec = Base64Coder.decode(enc);
		}catch(IllegalArgumentException e){
			e.printStackTrace();
		}
		return dec;		
	}
	
	
//start update result methods	
	
	/*
	 * This method takes a efficient XML result encoded as base64 and
	 * updates the screen whit the results
	 */
	protected void updateEfx(String efxBase64, long t, String name1){

			this.resScreen.clean();
			this.resScreen.setType("Efficient XML");
			byte[] efxBytes=this.Base64Decode(efxBase64);
			int antallByte = efxBytes.length;
			
			int anBy =(efxBase64.getBytes()).length;
			
			this.setRetTime(t, name1, anBy, "EFX");
			
			ByteArrayInputStream bais=null;
			EFXStreamReader readEfx;
			
			try{
				bais = new ByteArrayInputStream(efxBytes);
			}catch(Exception e){
				e.printStackTrace();
			}
	
			
			try {
				readEfx = efx.createEFXStreamReader(bais);
				readEfx.next(EFXStreamReader.START_ELEMENT);
				readEfx.next(EFXStreamReader.START_ELEMENT);
				//starts the measurements of the prossesing
				long start=System.currentTimeMillis();					
				boolean hasMore=true;
				while(hasMore){
						//System.out.println("starter efx lokke");
					Contact temp = new Contact();						
					//if(readEfx.next()==EFXStreamReader.START_ELEMENT){
					//readEfx.next(EFXStreamReader.START_ELEMENT); // <contact>
					readEfx.next(EFXStreamReader.CHARACTERS);
					temp.setFirstName(readEfx.getString());
					//System.out.println(readEfx.getString());
					readEfx.next(EFXStreamReader.START_ELEMENT);
					readEfx.next(EFXStreamReader.CHARACTERS);
					temp.setLastName(readEfx.getString());
					//System.out.println(readEfx.getString());
					readEfx.next(EFXStreamReader.START_ELEMENT);
	                readEfx.next(EFXStreamReader.CHARACTERS);
	                temp.setPhoneNumber(Integer.parseInt(readEfx.getString()));
	                //System.out.println(readEfx.getString());
	                readEfx.next(EFXStreamReader.START_ELEMENT);
	                readEfx.next(EFXStreamReader.CHARACTERS);
	                temp.setEMail(readEfx.getString());
	                //System.out.println(readEfx.getString());
	                readEfx.next(EFXStreamReader.START_ELEMENT);
	                readEfx.next(EFXStreamReader.CHARACTERS);
	                temp.setAddress(readEfx.getString());
	                //System.out.println(readEfx.getString());
	                readEfx.next(EFXStreamReader.START_ELEMENT);
	                readEfx.next(EFXStreamReader.CHARACTERS);
	                temp.setPostalCode(Integer.parseInt(readEfx.getString()));
	                //System.out.println(readEfx.getString());	              
	                readEfx.next(EFXStreamReader.START_ELEMENT);
	                readEfx.next(EFXStreamReader.CHARACTERS);
	                temp.setTown(readEfx.getString());
	               // System.out.println(readEfx.getString());	        
	                readEfx.next(EFXStreamReader.END_ELEMENT);
	                readEfx.next(EFXStreamReader.END_ELEMENT);
					//}
					if(readEfx.next()==EFXStreamReader.END_ELEMENT){
						hasMore=false;
					}	
					this.resScreen.addEntry(temp);	
				}
				long stop =System.currentTimeMillis();
				
				this.setTimePros(start, stop, antallByte);
				resScreen.setTimePros(stop-start);
				readEfx.close();
				bais.close();
				d.setCurrent(resScreen);
				//System.out.println(readEfx.getQName());
	
			} catch (EFXException e1) {
				StringItem feil3= new StringItem("Feil: ", "start feill3");
				this.resScreen.append(feil3);				
				d.setCurrent(resScreen);
				e1.printStackTrace();
			} catch (IOException e1) {
				StringItem feil4= new StringItem("Feil: ", "start feill4");
				this.resScreen.append(feil4);				
				d.setCurrent(resScreen);
				e1.printStackTrace();
			}
	}
	
	/*
	 * This method takes a  XML result encoded as base64 and
	 * updates the screen whit the results
	 */
	protected void updatePlainAsString(String plain, long retTime, String na){
		this.resScreen.clean();
		this.resScreen.setType("Plain as String");
		
		byte[] plainBytes = this.Base64Decode(plain);
		System.out.println(plainBytes.length);
		int anBy = plain.getBytes().length;
		
		this.setRetTime(retTime, na, anBy, "PLAIN");
		
		int antallByte = plainBytes.length;
		try {
			//plainBytes = Base64Coder.decode(plain);
			ByteArrayInputStream bais = new ByteArrayInputStream(plainBytes);
			SAXParserFactory fac = SAXParserFactory.newInstance();
			
			SAXParser saxP =fac.newSAXParser();
			
			long start = System.currentTimeMillis();
			saxP.parse(bais, new ContactHandler(this));
			long stop = System.currentTimeMillis();
			this.resScreen.setTimePros(stop-start);
			this.setTimePros(start, stop, antallByte);
			System.out.println("tid parse SAX: "+String.valueOf(stop-start));
			
			
			
			
			bais.close();
			d.setCurrent(resScreen);
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	protected void updateEfxAndZip(String efxZip, long retTime, String name){
		int bytesTrans = efxZip.getBytes().length;
		this.setRetTime(retTime, name, bytesTrans, "EFX_ZIP");
		this.resScreen.setType("EFX_ZIP");
		this.resScreen.setTimeRet(retTime);
		
		byte[] efxZip1=this.Base64Decode(efxZip);
		int bytesPros = efxZip1.length;
		resScreen.setTimePros(-1);
		this.setTimePros(0, (-1), bytesPros);
		//efx.setProperty(EFXProperty.ZIP, new Boolean(true));
		//ByteArrayInputStream bais = new ByteArrayInputStream(efxZip1);		
		//com.jcraft.jzlib.ZInputStream zIn = new com.jcraft.jzlib.ZInputStream(bais);
		//EFXStreamReader readEfx;
		/*	try {
			com.tinyline.util.GZIPInputStream gzi = new com.tinyline.util.GZIPInputStream(bais);
			readEfx = efx.createEFXStreamReader(gzi);			
			readEfx.next(EFXStreamReader.START_ELEMENT);
			readEfx.next(EFXStreamReader.START_ELEMENT);
			long start=System.currentTimeMillis();					
			boolean hasMore=true;
			while(hasMore){
					//System.out.println("starter efx lokke");
				Contact temp = new Contact();
					
				//if(readEfx.next()==EFXStreamReader.START_ELEMENT){

				//readEfx.next(EFXStreamReader.START_ELEMENT); // <contact>
				readEfx.next(EFXStreamReader.CHARACTERS);
				temp.setFirstName(readEfx.getString());
				//System.out.println(readEfx.getString());
				readEfx.next(EFXStreamReader.START_ELEMENT);
				readEfx.next(EFXStreamReader.CHARACTERS);
				temp.setLastName(readEfx.getString());
				//System.out.println(readEfx.getString());
				readEfx.next(EFXStreamReader.START_ELEMENT);
			    readEfx.next(EFXStreamReader.CHARACTERS);
			    temp.setPhoneNumber(Integer.parseInt(readEfx.getString()));
			    //System.out.println(readEfx.getString());
			    readEfx.next(EFXStreamReader.START_ELEMENT);
			    readEfx.next(EFXStreamReader.CHARACTERS);
			    temp.setEMail(readEfx.getString());
			    //System.out.println(readEfx.getString());
			    readEfx.next(EFXStreamReader.START_ELEMENT);
			    readEfx.next(EFXStreamReader.CHARACTERS);
			    temp.setAddress(readEfx.getString());
			    //System.out.println(readEfx.getString());
			    readEfx.next(EFXStreamReader.START_ELEMENT);

			    readEfx.next(EFXStreamReader.CHARACTERS);
			    temp.setPostalCode(Integer.parseInt(readEfx.getString()));
			    //System.out.println(readEfx.getString());
			   
			    readEfx.next(EFXStreamReader.START_ELEMENT);
			    readEfx.next(EFXStreamReader.CHARACTERS);
			    temp.setTown(readEfx.getString());
			   // System.out.println(readEfx.getString());
			   
			    readEfx.next(EFXStreamReader.END_ELEMENT);
			    readEfx.next(EFXStreamReader.END_ELEMENT);
				//}
				
				if(readEfx.next()==EFXStreamReader.END_ELEMENT){
					hasMore=false;
				}	
				this.resScreen.addEntry(temp);	
			}
			long stop =System.currentTimeMillis();
			
			this.setTimePros(start, stop, bytesPros);
			resScreen.setTimePros(stop-start);
			readEfx.close();
			bais.close();
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalStateException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (EFXException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		*/

		d.setCurrent(resScreen);	
	}
	
	protected void updateZlib(String result, long retTime, String name){
		int bytesTrans = result.getBytes().length;
		this.setRetTime(retTime, name, bytesTrans, "ZLIB");
		
		this.resScreen.clean();
		this.resScreen.setType("Zlib as String");
		
		byte[] zlibBytes = this.Base64Decode(result);
		int bytesPros =zlibBytes.length;
		System.out.println(zlibBytes.length);
		//start decoding
		long start = System.currentTimeMillis();
		
		ByteArrayInputStream is = new ByteArrayInputStream(zlibBytes);
		com.jcraft.jzlib.ZInputStream zIn = new com.jcraft.jzlib.ZInputStream(is);
		try {

			//parse res
			SAXParserFactory fac = SAXParserFactory.newInstance();
			SAXParser saxP =fac.newSAXParser();

			saxP.parse(zIn, new ContactHandler(this));
			long stop = System.currentTimeMillis();
			this.resScreen.setTimePros(stop-start);
			this.setTimePros(start, stop, bytesPros);
			System.out.println("tid parse SAX+zlib: "+String.valueOf(stop-start));
			
			zIn.close();
			is.close();
			d.setCurrent(resScreen);
	
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
	}
	

//slutt update result methods
	
	
	protected void destroyApp(boolean arg0) throws MIDletStateChangeException {
		this.updateMeasurements();
		
		//System.exit(0);
		this.notifyDestroyed();

	}

	protected void pauseApp() {
		// TODO Auto-generated method stub

	}

	protected void startApp() throws MIDletStateChangeException {
		Display d = Display.getDisplay(this);
		d.setCurrent(getForm());
		//getNumber();
	}

	
	/*protected void getNumber(String name){
		System.out.println("getNumerber i midlet");

		ws.setName(name);
		startT = new Date();
		new Thread(ws).start();


		
		}*/
		
		
	protected void showCompressionResults(CompressionResults cr){
		
		d.setCurrent(cr);
	}
		

	/*protected void setResults(String res, int type, long time){
		//this.resScreen.setTime(time);
		String info = name.getString()+" "+this.type+" "+"bytes "+res.getBytes().length+" "+ String.valueOf(time)+" ms";
		StringItem si = new StringItem("Result", info);
		resScreen.append(si);
		byte[] inBytes=null;

			try {
				inBytes = Base64.decode(res);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

		System.out.println("lengde bytes uten base64 "+inBytes.length);
		Display d = Display.getDisplay(this);
		d.setCurrent(resScreen);
	}*/
	
	

	/*protected void setNumber(ContactBook entries){
		this.resScreen.update(entries);
		//form.append("Nummer: "+String.valueOf(number.getNumber()));
		stopT = new Date();
		long tid = stopT.getTime()-startT.getTime();
		this.resScreen.setTimeRet(tid);
		System.out.println(tid);
		Display d = Display.getDisplay(this);
		d.setCurrent(resScreen);
		//form.append("TID :"+String.valueOf(tid)+"ms");
	}*/
	
	/*this method is used to perform different task, retreive information in different formats
	 * and to place a call.
	 * (non-Javadoc)
	 * @see javax.microedition.lcdui.ItemCommandListener#commandAction(javax.microedition.lcdui.Command, javax.microedition.lcdui.Item)
	 */
	public void commandAction(Command arg0, Item arg1) {
		
		String com = arg0.getLabel();
		System.out.println("item command"+com);
		Display d = Display.getDisplay(this);
		if(ready){
		if(com.equals("PLAIN")){
			ready= false;
			if(name.getString().equalsIgnoreCase("")){
			Alert inf=new Alert("Please type name!");
			inf.setType(AlertType.INFO);
			inf.setTimeout(5000);
			inf.setString("You have to type at least one charater" );

			d.vibrate(1000);
			d.setCurrent(inf, getForm());

			}
			else{
				type="PLAIN";
			name1 = name.getString();
			d.setCurrent(inf);
			ws.preapere(name.getString(), WsThread.PLAIN_STRING);
			Thread t=new Thread(ws);
			t.start();
			}

		}
		else if(com.equals("PROCESSING")){
			/*Compression c = new Compression(this);
			Thread cThread = new Thread(c);
			cThread.start();
			*/
			Processing p = new Processing(efx, this);
			Thread pT = new Thread(p );
			pT.setPriority(Thread.MAX_PRIORITY);
			pT.start();
		}
		else if(com.equalsIgnoreCase("EFX")){
			type="EFX";
			ws.preapere(name.getString(), WsThread.EFX);
			d.setCurrent(inf);
			Thread t= new Thread(ws);
			t.start();
		}
		else if(com.equalsIgnoreCase("ZLIB")){
			type="ZLIB";
			ws.preapere(name.getString(), WsThread.ZLIB);
			Thread t= new Thread(ws);
			t.start();
		}
		else if(com.equalsIgnoreCase("EFX_ZIP")){
			type="EFX_ZIP";
			ws.preapere(name.getString(), WsThread.EFX_ZIP);
			Thread t= new Thread(ws);
			t.start();
		}
		else if(com.equalsIgnoreCase("TEST")){
			type="TEST";
			ws.preapere(name.getString(), WsThread.TEST);
			Thread t= new Thread(ws);
			t.start();
		}
		}
		else if(com.equals("Call")){
			System.out.println(arg1.getLabel());
			StringItem it = (StringItem)arg1;
			try {
				this.platformRequest("tel:"+it.getText());
			} catch (ConnectionNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
	
	/*This methods are used to go back from other diplayables
	 * (non-Javadoc)
	 * @see javax.microedition.lcdui.CommandListener#commandAction(javax.microedition.lcdui.Command, javax.microedition.lcdui.Displayable)
	 */
	public void commandAction(Command arg0, Displayable arg1) {
		System.out.println("command"+ arg1.getClass().getName());
		if(arg1.equals(resScreen)){
			if(arg0.getCommandType()==Command.BACK){
				ready=true;
				//this.name.delete(0, name.size());
				Display d = Display.getDisplay(this);
				d.setCurrent(getForm());
				//this.resScreen.clean();
			}
		}
		else if(arg1.getClass().getName().equalsIgnoreCase("client.mid1.CompressionResults")){
			Display d = Display.getDisplay(this);
			d.setCurrent(getForm());
		}
		
		// TODO Auto-generated method stub
		
	}


	public void initButtons(){
		resScreen = new Result("Phone book entries", this);
		name = new TextField(null, null, 15, 0);
		inputQ.setLabel("Please type name: ");
		inputQ.setLayout(javax.microedition.lcdui.StringItem.LAYOUT_TOP);
		getForm().append(inputQ);
		getForm().append(name);
		res = new String[9];

	

		
		okButton = new StringItem("PLAIN", null, javax.microedition.lcdui.Item.BUTTON);
		Command okCom = new Command("PLAIN", Command.OK, 1);
		okButton.addCommand(okCom);
		okButton.setItemCommandListener(this);
		getForm().append(okButton);
		
		zLibButton = new StringItem("ZLIB", null, javax.microedition.lcdui.Item.BUTTON);
		Command zlib = new Command("ZLIB", Command.SCREEN, 1);
		zLibButton.addCommand(zlib);
		zLibButton.setItemCommandListener(this);
		getForm().append(zLibButton);
		
		efxButton = new StringItem("EFX", null, javax.microedition.lcdui.Item.BUTTON);
		Command efx = new Command("EFX", Command.SCREEN, 1);
		efxButton.addCommand(efx);
		efxButton.setItemCommandListener(this);
		getForm().append(efxButton);
		
		ezButton = new StringItem("EFX_ZIP", null, javax.microedition.lcdui.Item.BUTTON);
		Command ezCom = new Command("EFX_ZIP", Command.OK, 1);
		ezButton.addCommand(ezCom);
		ezButton.setItemCommandListener(this);
		getForm().append(ezButton);
		
		testButton = new StringItem("TEST", null, javax.microedition.lcdui.Item.BUTTON);
		Command test = new Command("TEST", Command.SCREEN, 1);
		testButton.addCommand(test);
		testButton.setItemCommandListener(this);
		getForm().append(testButton);
		
		compButton = new StringItem("PROCESSING", null, javax.microedition.lcdui.Item.BUTTON);
		Command compCom = new Command("PROCESSING", Command.SCREEN, 1);
		compButton.addCommand(compCom);
		compButton.setItemCommandListener(this);
		getForm().append(compButton);
	}
	
	
}
